Ticket #42988

Assert 'state == TECH_UNKNOWN' failing

Open Date: 2021-10-06 20:58 Last Update: 2021-11-19 01:42

Reporter:
Owner:
Type:
Status:
Closed
Component:
MileStone:
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Fixed
File:
1

Details

I have a codebase forked from the master summer -19. So far in my debugging I've not seen any difference between current master and this forked codebase that would make current master safe from the assert.

I'm regularly seeing assert 'state == TECH_UNKNOWN' from research_update() failing on a client, with global observer. With my debugging attempts (increased logging from a game to game, really) I think:
- State is actually 'TECH_PREREQS_KNOWN', and that's correct
- There should be no rules preventing researching the tech, so 'reachable' should be TRUE, causing code to go in the different branch in previous 'if' (assert is in the 'else' branch)
- 'reachable' seems to be FALSE because research_may_become_allowed() macro returns FALSE -> research_allowed() returns FALSE
- reqs_may_activate() has never in the entire run returned FALSE
- As far as I see this leaves only the possibilities for the research_allowed() to return FALSE because advance is not valid (it should not be, they have valid name at least), or that research_players_iterate() iterates over zero players (as the first iterated player would cause it to return TRUE from reqs_may_activate() )

Ticket History (3/6 Histories)

2021-10-06 20:58 Updated by: cazfi
  • New Ticket "Assert 'state == TECH_UNKNOWN' failing" created
2021-10-07 23:11 Updated by: cazfi
Comment

Still investigating, but the issue seem to be with this code in (server side) end_turn():

researches_iterate(presearch) {
send_research_info(presearch, NULL);
} researches_iterate_end;

Similar code exist in send_all_info(), which probably causes similar issue.

researches_iterate() iterate over *all* researches, including those that have only dead players. That means that a dead player's research gets sent to the client. That research_players_iterate() on client side discussed earlier will skip dead players, so for a dead player's research it iterates over zero players, which I already assumed to be the problem.

I'm not yet sure what the correct fix would be, or even if it should be server side (never to send dead player's research), or client side (somehow to handle dead player's research).

(Edited, 2021-10-07 23:12 Updated by: cazfi)
2021-10-21 06:52 Updated by: cazfi
  • Milestone Update from (None) to 3.0.0 (closed)
  • Component Update from (None) to General
2021-11-08 06:10 Updated by: cazfi
  • Resolution Update from None to Accepted
2021-11-19 01:42 Updated by: cazfi
  • Status Update from Open to Closed
  • Owner Update from (None) to cazfi
  • Resolution Update from Accepted to Fixed

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login